% :- module( graphs, [graphs/2] ).

:- ensure_loaded( '../src/init_lib' ).
:- ensure_loaded( library(pl) ).
:- ensure_loaded( library(term_in_file_contiguous_counts) ).
:- ensure_loaded( library(kv_additive_consolidation) ).
:- ensure_loaded( library(kv_transpose) ).
:- ensure_loaded( library(kv_decompose) ).
:- ensure_loaded( library(default_tmp_directory) ).		% /1.
:- ensure_loaded( library(mktemp_in_dir) ).				% /3.
:- ensure_loaded( library(write_list_elem_per_line) ).		% /1.
:- ensure_loaded( library(write_list_elem_per_line_w_period) ).% /1.
:- ensure_loaded( library(flatoms) ).					% /2.
:- ensure_loaded( library(gnucomfile) ).			% /2.
% :- ensure_loaded( library(wake_up) ).					% /2.

:- multifile( exec_extension/2 ).
:- dynamic( exec_extension/2 ).

exec_extension( graphs, BareFile ) :-
	term_in_file_contiguous_counts( BareFile, c( _Any ), RevCounts ),
	reverse( RevCounts, Counts ),
	kv_decompose( Counts, _CountsKeys, CountsValues ),
	kv_additive_consolidation( Counts, Consol ),
	kv_transpose( Consol, Trans ),
	keysort( Trans, TranSort ),
	kv_decompose( TranSort, AdditiveKeys, _Values ),
	% default_tmp_directory( TmpDir ),
	atom_concat( BareFile,'.stays', DataFile1 ),
	atom_concat( BareFile,'.visits', DataFile2 ),
	% % mktemp_in_dir( gnuplotdata_XXXXXX, '.', DataFile1 ),
	% % mktemp_in_dir( gnuplotdata_XXXXXX, '.', DataFile2 ),
	mktemp_in_dir( gnuplotcoms_XXXXXX, '.', GnuComsFile ),
	current_output( OldOut ),
	tell( DataFile1 ),
	write_list_elem_per_line( CountsValues ), 
	told,
	tell( DataFile2 ),
	write_list_elem_per_line( AdditiveKeys ), 
	told,
	sleep( 3 ),
	flatoms( ['gnuplot -persist \"',GnuComsFile,'\"'], GplotSc ),
	flatoms( ['gnuplot -persist \"',GnuComsFile,'\"'], GplotPs ),
	gnucomfile_w_lines( GnuComsFile, DataFile1 ),
	exec( GplotSc, [null,null,null], _Pid1 ),
	sleep( 3 ),
     atom_concat( DataFile1, '.ps', Ps1 ),
     Opts1 = [with(lines),output(Ps1),term(postscript)],
     gnucomfile( GnuComsFile, Opts1, DataFile1 ),
     system( GplotPs ),
     sleep( 3 ),
	gnucomfile_w_lines( GnuComsFile, DataFile2 ),
	exec( GplotSc, [null,null,null], _Pid2 ),
     sleep( 3 ),
     atom_concat( DataFile2, '.ps', Ps2 ),
     Opts2 = [with(lines),output(Ps2),term(postscript)],
     gnucomfile( GnuComsFile, Opts2, DataFile2 ),
     system( GplotPs ),
	sleep( 2 ),
	delete_file( GnuComsFile ),
	set_output( OldOut ).
	% wake_up.
