
/* 
     Converts a .pl data/n files to conrresponding .txt files.
   */

:- ensure_loaded( library(lists) ).

textify_data( [] ).
textify_data( [F|Fs] ) :-
     write( doing(F) ), nl,
     ( atom_concat(Stem,'.pl',F) ->
          true
          ;
          Stem = F
     ),
     atom_concat( Stem, '.txt', Txt ),
     open( F, read, In ),
     open( Txt, write, Out ),
     read( In, Term ),
     textify_data_stream( Term, In, Out ),
     close( In ),
     close( Out ),
     textify_data( Fs ).

textify_data_stream( end_of_file, _In, _Out ) :- !.
textify_data_stream( Term, In, Out ) :-
     ( Term =.. [data|Args] ->
          flatten( Args, Flat ),
          list_to_data_line( Flat, Out )
          ;
          true
     ),
     read( In, Next ),
     textify_data_stream( Next, In, Out ).

list_to_data_line( [], _Out ).
list_to_data_line( [H|T], Out ) :-
     write( Out, H ), 
     ( T == [] -> nl( Out ) ; write( Out, ' ' ) ),
     list_to_data_line( T, Out ).
