:- ensure_loaded( n_samples ).		%.
:- ensure_loaded( library(system) ).	% delete_file/1.
% :- needs( model_to_data_point/2 ).

n_data_points( File, Opts ) :-
	n_samples( Opts, Tmp, Freqs ),
	delete_file( Tmp ),
	open( File, write, Out ),
	record_data_points( Freqs, Out ), 
	close( Out ).

record_data_points( [], _Out ).
record_data_points( [Model-Tms|T], Out ) :-
	model_to_data_point( Model, Point ),
	record_data_point_n_tms( Tms, Point, Out ),
	record_data_points( T, Out ).

record_data_point_n_tms( Tms, _Point, _Out ) :-
	Tms < 1, 
	!.
record_data_point_n_tms( Tms, Point, Out ) :-
	writeq( Out, Point ), write( Out, '.' ), nl( Out ),
	NxTms is Tms - 1,
	record_data_point_n_tms( NxTms, Point, Out ).
