:- ensure_loaded( '../../src/init_lib' ).

:- ensure_loaded( library(default_tmp_directory) ).	% /1.
:- ensure_loaded( library(mktemp_in_dir) ).			% /3.
:- ensure_loaded( library(bn_to_dot_dag) ).			% /3.
:- ensure_loaded( library(system) ).		          % /1.
:- ensure_loaded( library(lists) ).		          % flatten/2, ...
:- prolog_load_context( directory, LoadDir ), 
   atom_codes( LoadDir, LoadDirCs ),
   bb_put( disp_dag_directory, LoadDirCs ).

% 
/*  NOTE : to create bns that have nodes with empty style, 
           use disp_bn/3, export in png and use gimp to convert to .eps... 

disp_bn( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]] ).
disp_bn( [1-[],2-[1,4],3-[1],4-[1],5-[],6-[],7-[1,2,3,4,5,6],8-[2]], [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]] ).
% red edges (ok) yellow edges (new) magenta (missing)
disp_bn( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]], [1-[],2-[1],3-[5],4-[],5-[4],6-[4],7-[5],8-[3,6]] ). % the best learned...
disp_bn( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]], [1-[],2-[1],3-[5],4-[],5-[4],6-[4],7-[5],8-[3,6]], [node_style(empty)] ). % as above with non-filled style nodes
disp_dag /usr/nicos/islp/bn_lbl_kernel/slp/disp/asia.dot 
/local/usr/src/graphviz-1.10/tcldot/demo/doted
 
disp_bn( [1-[2],3-[4,5]] ).
 
2006: disp_bn( [1-[],2-[a],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]], [a-[],2-[a],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]], [colour(bnw),edge_style(empty)] ).
*/

disp_asia([]) :- 
	disp_asia.
disp_asia :-
	disp_bn( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]] ).

disp_bn( Bn ) :-
	disp_bn( Bn, Bn ).

disp_bn( Bn, Against ) :-
	disp_bn( Bn, Against, [] ).
disp_bn( Bn, Against, Opts ) :-
	default_tmp_directory( TmpDir ),
	mktemp_in_dir( tmp_XXXXXX, TmpDir, DotFile ),
	bn_to_dot_dag( Bn, Against, DotFile, Opts ),
	exec_dag_disp( DotFile ),
	sleep( 2 ),
	% ( bb_get(first_bn,false) -> sleep( 1 ) 
		% ; sleep(2), bb_put( first_bn, false ) ),
     ( memberchk(rmv(false),Opts) ->
          true
          ;
	     delete_file( DotFile )
     ).

exec_dag_disp( DotFile ) :-
	atom_codes( DotFile, DotFileCs ),
	( shell(' which doted 2> /dev/null ' ) ->
		Doted = "doted " 
		;
		bb_get( disp_dag_directory, DispDagDirCs ),
		flatten( [DispDagDirCs,"/disp_dag "], Doted )
	),
	%% flatten( [Doted,DotFileCs," >& /dev/null "], DispCs ),
	flatten( [Doted,DotFileCs, " & "], DispCs ),
	atom_codes( Disp, DispCs ),
	shell( Disp ).
	% exec( Disp, [null,null,null], _Pid ).
