
/* 
     pupsh ~/islp/mcmcms/bns/auxil/disp_mvis 
*/
:- ensure_loaded( edge_difs ).     % /5.
:- requires( disp_graph/2 ).
:- requires( kv_compose_fixed_v/3 ).

disp_mvis( File ) :-
     open( File, read, In ),
     read( In, Term ), 
     disp_mvis_stream( Term, 1, null__, In ),
     close( In ).

disp_mvis_stream( eof, _, _Last, _In ) :- !.
disp_mvis_stream( end_of_file, _I, _Last, _In ) :- !.
disp_mvis_stream( Tms-c(Bn), I, Last, In ) :-
     !,
     bns_diff( Last, Bn, _Ce, Pe, Rev ),
     term_to_dbl_quoted_atom( I:Tms, PrpTitle ),
     % kv_compose_fixed_v( Ce, [color(blue)], OnlyInC ),
     kv_compose_fixed_v( Pe, [color(blue)], OnlyInP ),
     % kv_compose_fixed_v( Ce, [color(blue)], OnlyInC ),
     kv_compose_fixed_v( Pe, [color(blue)], OnlyInP ),
     kv_compose_fixed_v( Rev, [color(brown)], RevInP ),
     append( OnlyInP, RevInP, PClrs ),
     Popts = [edges_colours(PClrs), background(true), title(PrpTitle) ],
     disp_graph( Bn, Popts ),
     write( ' Press return to continue (0 first, to stop) : ' ),
     flush_output,
     read_line_to_codes( user_input, What ),
     % atom_codes( Atm, What ),
     % write( atom(Atm)-what(What) ), nl,
     ( What = [0'0] -> 
          flush_output, 
          flush_output(user_error),
          abort
          ; 
          write( user_error, What), nl(user_error)
     ),
     NxtI is I + 1,
     read( In, Next ),
     disp_mvis_stream( Next, NxtI, Bn, In ).
disp_mvis_stream( Other, _I, _Bn, _In ) :-
     write( oter(Other) ), nl,
     abort.

bns_diff( null__, _, [], [], [] ) :- !.
bns_diff( BnOld, BnNew, Ce, Pe, Rev ) :-
     edge_difs( BnOld, BnNew, Ce, Pe, Rev ).

term_to_dbl_quoted_atom( Term, Title ) :-
     write_to_chars( Term, NkdTitleCs ),
     append( [0'"|NkdTitleCs], [0'"], TitleCs ),
     atom_codes( Title, TitleCs ).
