
/* Find the edge differences between two BNs. */

:- ensure_loaded( library(ordsets) ).

edge_difs( Bn1, Bn2, Dir1, Dir2, Rev ) :-
     edge_difs_1( Bn1, Bn2, In1/[], In2/[] ),
     find_reversed( In2, In1, Dir2, Dir1, Rev ).

find_reversed( [], Rem, [] , Rem, [] ).
find_reversed( [A-B|T], Edges, L1, L2, Rev ) :-
     ( select(B-A,Edges,Rem) ->
          L1 = T1,
          Rev = [A-B|TRev]
          ;
          L1 = [A-B|T1], 
          Rem = Edges,
          Rev = TRev
     ),
     find_reversed( T, Rem, T1, L2, TRev ).

edge_difs_1( [], [], In1/In1, In2/In2 ).
edge_difs_1( [Nd-Pa1|T1], [Nd-Pa2|T2], In1/Tin1, In2/Tin2 ) :-
     ord_subtract( Pa1, Pa2, OnlyIn1 ),
     ord_subtract( Pa2, Pa1, OnlyIn2 ),
     thread( OnlyIn1, Nd, In1, Cin1 ),
     thread( OnlyIn2, Nd, In2, Cin2 ),
     edge_difs_1( T1, T2, Cin1/Tin1, Cin2/Tin2 ).


thread( [], _Ch, Cin, Cin ).
thread( [H|T], Ch, [H-Ch|R], Cin ) :-
     thread( T, Ch, R, Cin ).
