:- ensure_loaded( library(lists) ).		% memberchk/2.
:- ensure_loaded( library(ordsets) ).		% ord_intersection/4.

:- requires( werr/2 ).   % werrh/2

red_cart_to_full( CartIn, Depth, InIds, CartOut ) :-
     ( InIds = ids(Ids,_NofIds) ->
          Ord = id_feature
          ;
          Ids = InIds,
          Ord = feature_ids
     ),
     red_cart_to_full( CartIn, Depth, Ord, Ids, CartOut ).

red_cart_to_full( l, D, _Ord, Ids, leaf(D,Ids) ) :- !.
red_cart_to_full( cr(F,Fvl,L,R), D, Ord, Ids, cart(F,Fvl,Lfull,Rfull) ) :-
	bb_get( F, FIndex ), 
     ( Ord == feature_ids ->
	     memberchk( Fvl-PointIds, FIndex )
          ;
          ( Ord == id_feature ->
               findall( Id, (member(Id-IdV,FIndex),
                             compare(Op,IdV,Fvl),
                             Op \== (>)), PointIds )
               ;
               werrh( unknown_order_var_in_red_cart_to_full(Ord), 2 )
          )
     ),
	ord_intersection( PointIds, Ids, LIds, RIds ),
	NxtD is D + 1,
	red_cart_to_full( L, NxtD, Ord, LIds, Lfull ),
	red_cart_to_full( R, NxtD, Ord, RIds, Rfull ).

reduced_cart_model( l ) :- !.
reduced_cart_model( cr(_,_,_,_) ).
