:- ensure_loaded( '../../../../src/init_lib' ).
:- ensure_loaded( 'bcw_data' ).
:- ensure_loaded( '../../../src/cart_llhood' ).
:- ensure_loaded( '../src/display_model' ).
:- ensure_loaded( chipman_best_skeleton ).
:- ensure_loaded( '../slps/sicstus_ord_intersection' ).
% :- ensure_loaded( 'bcw' ).
		% ord_intersection_pl/4

chipman_best( [] ) :-
	bcw_data( _, _ ),
	findall( [A,B,C,D,E,F,G,H,I]-Class, data(A,B,C,D,E,F,G,H,I,Class), DataPairs ),
	data_pairs_to_skeleton_data( DataPairs, 1, Data ),
	chipman_best_skeleton( Skel ),
	decision_cart_to_cart( Skel, Data, 0, Cart ),
	cart_llhood( Cart, LLhood ),
	display_model( Cart, [title(chipman_et_al),lhood(LLhood)] ).

/*
chipman_best_six_cart( SxCart, LvsList, NdPsts ) :-
	bcw_data( Ids, Pssbls ),
	chipman_best_skeleton( Skel ),
	skeleton_possibles_to_six_cart( Skel, 0, Ids, Pssbls, SxCart, LvsList/[], [], NdPsts/[]  ).
*/

skeleton_possibles_to_six_cart( cart(F,Ch,L,R), D, Ids, Pssbls, FvCart, Lvs/Tls, Acc, Psts/Tps ) :-
	select( f(F,FChs), Pssbls, TPssbls ),
	select( s(Ch,AllLIds,_AllRIds), FChs, NxFChs ),
	!,
	( NxFChs = [] ->
		NxPssbls = TPssbls
		;
		NxPssbls = [f(F,NxFChs)|TPssbls]
	),
	reverse( Acc, ThisPst ),
	Psts = [ThisPst|InLPsts],
	NxD is D + 1,
	ord_intersection_pl( AllLIds, Ids, LIds, RIds ),
	skeleton_possibles_to_six_cart( L, NxD, LIds, NxPssbls, LFv, Lvs/TlsL, [l|Acc], InLPsts/TpsL ),
	skeleton_possibles_to_six_cart( R, NxD, RIds, NxPssbls, RFv, TlsL/Tls, [r|Acc], TpsL/Tps ),
	FvCart = cart( F, Ch, Ids, Pssbls, LFv, RFv ).
skeleton_possibles_to_six_cart( leaf, D, Ids, Pssbls, FvCart, Lvs/Tls, _Acc, Psts/Psts ) :-
	Lvs = [leaf(D,Ids,Pssbls)-FvCart|Tls].

chipman_best_cart( Cart ) :-
	bcw_data( _, _ ),
	findall( [A,B,C,D,E,F,G,H,I]-Class, data(_,A,B,C,D,E,F,G,H,I,Class), DataPairs ),
	data_pairs_to_skeleton_data( DataPairs, 1, Data ),
	chipman_best_skeleton( Skel ),
	decision_cart_to_cart( Skel, Data, 0, Cart ).

decision_cart_to_cart( cart(F,Val,L,R), Data, Depth, cart(F,Val,Cl,Cr) ) :-
	split_data_on_feature( Data, F, Val, LeftD, RightD ),
	NxDepth is Depth + 1,
	decision_cart_to_cart( L, LeftD, NxDepth, Cl ),
	decision_cart_to_cart( R, RightD, NxDepth, Cr ).
decision_cart_to_cart( leaf, Data, Depth, leaf(Depth,Ids) ) :-
	skeleton_data_to_ids( Data, Ids ).

skeleton_data_to_ids( [], [] ).
skeleton_data_to_ids( [d(_FList,_Class,Id)|T], [Id|Ids] ) :-
	skeleton_data_to_ids( T, Ids ).

data_pairs_to_skeleton_data( [], _N, [] ).
data_pairs_to_skeleton_data( [Flist-Cat|T], N, [d(Flist,Cat,N)|R] ) :-
	NxN is N + 1,
	data_pairs_to_skeleton_data( T, NxN, R ).

split_data_on_feature( [], _F, _Val, [], [] ).
split_data_on_feature( [d(Flist,Cat,Id)|T], F, Val, LeftD, RightD ) :-
	nth( F, Flist, ListVal ),
	( ListVal > Val ->
		RightD = [d(Flist,Cat,Id)|TRight], LeftD = TLeft
		;
		LeftD = [d(Flist,Cat,Id)|TLeft], RightD = TRight
	),
	split_data_on_feature( T, F, Val, TLeft, TRight ).
