:- ensure_loaded( '../../../src/init_lib' ).			% library_directory/1
:- ensure_loaded( pima ).							% data/8.
:- elm( 'carts/src/kategories_to_ids' ).		% /3.
% :- ensure_loaded( '../../../../bns/src/llhood/logamma' ).	% /2.
% :- ensure_loaded( library(write_list_elem_per_line) ).	% /1.
:- ensure_loaded( library(ordsets) ).					% /1.

% not_vacuous( [_,_,_,_,_|_] ).
not_vacuous_length( 5 ).

/*
% gen_cmv_sets( +NofFeatures, -Ids, -Sets ).
cmv_sets :-
	gen_cmv_sets( 8, _Ids, _Sets ).
	% write( ids(Ids) ), nl.
	% write_list_elem_per_line( Sets ), nl.
	*/

pima_cmvd( NofFeatures, Ids, Sets ) :-
	nof_features_constructs( NofFeatures, Datum, DCall ), 
	findall( Datum, DCall, Data ),
	kv_decompose( Data, FeatureVecs, Kategories ),
	kategories_to_ids( Kategories, 1, Ids ),
	list_to_ord_set( Kategories, Kats ),
	length( Kats, K ),
	bb_put( all_categories, Kats ),
	bb_put( num_of_categories, K ),
	logamma( K, LogK ),
	bb_put( knorm, LogK ),
	fvecs_gen_cmv_sets( FeatureVecs, 1, Sets ).
	% fvecs_gen_cmv_sets( FeatureVecs, 1, Ids, Sets ). % Ids only for testing

fvecs_gen_cmv_sets( [], _, [] ) :- !.
fvecs_gen_cmv_sets( FVecsPrs, Ith, [HSet|TSets] ) :-
	feature_val_skim_and_pairs( FVecsPrs, 1, Skimmed, FValIdPrs, RemFVctPrs ),
	sort( Skimmed, SrtFVals ),
	split_value_and_set_pairs( SrtFVals, FValIdPrs, [], RgtIds, Lefts ),
	HSet = row(Ith,Lefts,RgtIds),
	NxI is Ith + 1,
	% write( HSet ), nl,
	% row_sanity_check( Lefts, [], RgtIds, InRowIds ),
	% ( InRowIds==Ids -> true % write( ok_line(Ith) ), nl 
		% ; ord_subtract( Ids, InRowIds, Diff ), 
			% write( problem_with_line(Ith,Diff,RgtIds) ), nl, abort ),
	fvecs_gen_cmv_sets( RemFVctPrs, NxI, TSets ).

/*
row_sanity_check( [], Acc, Rgt, All ) :-
	ord_union( Acc, Rgt, All ).
row_sanity_check( [_-NstIds|T], Acc, Rgt, All) :-
	ord_union( Acc, NstIds, NxAcc, NewOnes ),
	( NewOnes == NstIds -> true; write( error_is_here(NstIds,Acc)), nl, abort ),
	row_sanity_check( T, NxAcc, Rgt, All ).
*/

split_value_and_set_pairs( [], _FValIdPrs, _Acc, _Rgt,  [] ).
split_value_and_set_pairs( [H|T], FValIdPrs, Acc, Rgt, DjnSet ) :-
	remove_left_fvalidprs_on_val( FValIdPrs, H, Left, RemFValIdPrs ),
	( is_list(Acc) -> ord_union( Acc, Left, Ids ) ; Ids = Left ),
     length( RemFValIdPrs, RemFValIdLgt ),
	not_vacuous_length(Lim),
	( RemFValIdLgt > Lim -> 
		Rem = T,
		NxRgt = Rgt,
		Rgt = NxRgt,
		( is_list(Acc) -> 
               length( Ids, IdsLgt ),
			( IdsLgt > Lim ->
				NxAcc is 0,
				DjnSet = [H-Ids|TDjnSet]
				;
				NxAcc = Ids, 
				TDjnSet = DjnSet
			)
			;
			NxAcc is 0,
			DjnSet = [H-Ids|TDjnSet]
		)
		;
		( T == [] -> 	% there is never point splitting on last value.
			% write( in_empty_t(Ids,RemFValIdPrs) ), nl,
			Rgt = Ids,
			DjnSet = []
			;
			Rem = [], % doesnt matter how many Rem are left.
			kv_decompose( RemFValIdPrs, _FVals, RightIds ),
			ord_union( Ids, RightIds, Rgt ),
			DjnSet = []
			% NxRgt, NxAcc, TDjnSet = _
		)
	),
	split_value_and_set_pairs( Rem, RemFValIdPrs, NxAcc, NxRgt, TDjnSet ).

feature_val_skim_and_pairs( [], _, [], [], [] ).
feature_val_skim_and_pairs( [[H|R]|T], N, [H|TVs], [H-N|TPrs], Rem ) :-
	( R == [] -> TRem = Rem ; Rem = [R|TRem] ),
	NxN is N + 1,
	feature_val_skim_and_pairs( T, NxN, TVs, TPrs, TRem ).

remove_left_fvalidprs_on_val( [], _Piv, [], [] ).
remove_left_fvalidprs_on_val( [Hv-Hid|T], Pivot, Left, Rem ) :-
	( Hv =< Pivot -> 
		Left = [Hid|TLeft], TRem = Rem
		;
		TLeft = Left, Rem = [Hv-Hid|TRem]
	),
	remove_left_fvalidprs_on_val( T, Pivot, TLeft, TRem ).

% extract_ids_from_fvecs( RemFVecsPrs, RightIds )

/*
% gen_cmv_sets( NofFeatures, CurrId, Ids, Sets ) :-
gen_cmv_sets( 0, _CurrId, _Empty, [], [] ) :- !.
gen_cmv_sets( FeatureCnt, NofFeatures, Data, CurrId, [CurrId|TIds], Sets ) :-
	Idx is NofFeatures - FeatureCnt + 1,
	gen_cmv_set( Idx, ),
	NxCnt is FeatureCnt - 1,
	NxId is CurrId + 1,
	gen_cmv_sets( NxCnt, NofFeatures, RemData, NxId, TIds, TSets ).
	*/

nof_features_constructs( NofFeatures, Datum, DCall ) :-
	functor( Datum, -, 2 ),
	DataArgs is NofFeatures + 1,
	functor( DCall, data, DataArgs ),
	arg( 1, Datum, DtmList ),
	arg( 2, Datum, Kat ),
	noff_to_data_call( NofFeatures, NofFeatures, DCall, DtmList, Kat ).

noff_to_data_call( 0, NofFtrs, DCall, [], Kat ) :-
	!,
	KatIdx is NofFtrs + 1,
	arg( KatIdx, DCall, Kat ).
noff_to_data_call( Cnt, NofFtrs, DCall, [H|T], Kat ) :-
	Idx is NofFtrs - Cnt + 1,
	arg( Idx, DCall, H ),
	NxCnt is Cnt - 1,
	noff_to_data_call( NxCnt, NofFtrs, DCall, T, Kat ).
