% assumes logamma/2, and not_vacuous/1.

:- ensure_loaded( library(ordsets) ).		% list_to_ord_set/2.
:- elm( 'carts/src/kategories_to_ids' ).

:- ensure_loaded( library(kv_decompose) ).	% /3.

% Data = [[FeatureVec]-Kat|...]
% FTypes = [{n,q}*]
%
%
% data_to_split_root( Data, FTypes ) :-
data_to_split_root( Data, Splits, Ids ) :-
	kv_decompose( Data, FeatureVecs, Kategories ),
	kategories_to_ids( Kategories, 1, Ids ),
	list_to_ord_set( Kategories, Kats ),
	length( Kats, K ),
	bb_put( all_categories, Kats ),
	bb_put( num_of_categories, K ),
	logamma( K, LogK ),
	bb_put( knorm, LogK ), 
	feature_bb_puts( FeatureVecs, 1, Splits ).
	
feature_bb_puts( [], _1, [] ).
feature_bb_puts( [H|T], I, [I-SplitVs|Tsps] ) :-
	feature_val_skim( [H|T], Fvs, Rem ),
	sort( Fvs, UnqSrtFVals ),
	feature_index( UnqSrtFVals, Fvs, 1, SplitVs, IthIndex ),
	bb_put( I, IthIndex ),
	NxI is I + 1,
	feature_bb_puts( Rem, NxI, Tsps ).

feature_val_skim( [], [], [] ).
feature_val_skim( [[H|R]|T], [H|TVs], Rem ) :-
	( R == [] -> TRem = Rem ; Rem = [R|TRem] ),
	feature_val_skim( T, TVs, TRem ).

feature_index( [], _Fvs, _Ith, [], [] ).
feature_index( [H|T], Fvs, I, SplitVs, Index ) :-
	val_dichotomy( Fvs, H, 1, LessOrEq, Greater ),
	( (not_vacuous(LessOrEq),not_vacuous(Greater)) ->
		SplitVs = [H|TSplitVs],
		Index = [H-LessOrEq|TIndex]
		;
		TSplitVs = SplitVs, TIndex = Index
	),
	NxI is I + 1,
	feature_index( T, Fvs, NxI, TSplitVs, TIndex ).

val_dichotomy( [], _, _I, [], [] ).
val_dichotomy( [H|T], Pivot, I, LOrE, G ) :-
	( Pivot @< H ->
		TLOrE = LOrE, G = [I|TG]
		;
		LOrE = [I|TLOrE], G = TG
	),
	NxI is I + 1,
	val_dichotomy( T, Pivot, NxI, TLOrE, TG ).
