:- module( branch_split_nbc, [branch/3] ).
/* 
s -f
compile( branch_split_nbc ), save_modules( [branch_split_nbc], branch_split_nbc), halt.
*/

:- ensure_loaded( library(ordsets) ).		% ord_intersection/4.

branch( [], _Restr, [] ).
branch( [f(F,Psbls)|T], Restr, FRestr ) :-
	branch_possibles( Psbls, Restr, PrvRestr ),
	% restricts( PrvRestr, F, FRestr, TFRestr ),
	( PrvRestr == [] ->
		FRestr = TFRestr
		;
		FRestr = [f(F,PrvRestr)|TFRestr]
	),
	branch( T, Restr, TFRestr ).

% restricts( [], _F, TRestr, TRestr ).
% restricts( [H|T], F, [f(F,[H|T])|TFRestr], TFRestr ).

branch_possibles( [], _Restr, [] ).
branch_possibles( [s(F,L,R)|T], Restr, Psbls ) :-
	ord_intersection( Restr, L, NwL ),
	ord_intersection( Restr, R, NwR ),
	% not_vacuous_constructs( NwL, NwR, F, Psbls, TPsbls ),
	( (user:not_vacuous( NwL ), user:not_vacuous( NwR ) ) ->
		Psbls = [s(F,NwL,NwR)|TPsbls]
		;
		Psbls = TPsbls
	),
	branch_possibles( T, Restr, TPsbls ).

% not_vacuous_constructs( [L1,L2,L3,L4,L5|LT], [R1,R2,R3,R4,R5|RT], F, All, Tail ) :-
	% !,
	% All = [s(F,[L1,L2,L3,L4,L5|LT],[R1,R2,R3,R4,R5|RT])|Tail].
% not_vacuous_constructs( _, _, _F, All, All ).
