% changed by Nicos on 2005/01/11. Along the lines discussed with James.
% ie. we dont use a findall any more.
/* in a batch of 10000 simplified iterations we had,
Old: 
dtm(datime(2005,1,12,17,7,3))
dtm(datime(2005,1,12,17,7,31))
New:
dtm(datime(2005,1,12,17,7,49))
dtm(datime(2005,1,12,17,8,0))
more testing needed
*/


:- dynamic( n_table/3 ).

:- ensure_loaded( set_class_weights ).
% :- dynamic( class_weight/2 ).

% :- use_module(library(terms)).

:- ensure_loaded( '../../src/init_lib' ).
:- pl( sicstus(_S), elm( 'bns/src/llhood/logamma_sicstus' ) ).
:- pl( yap(_Y), elm('bns/src/llhood/logamma_yap') ).
:- pl( swi(_P), elm('bns/src/llhood/logamma_swi') ).
:- ensure_loaded( library(kv_compose_fixed_v) ). % /3.

% Things to check with James.
% Log ? 
% exclusion of constant term ok ?
%
% excluding constant term that is
%
% These assume Alpha_i = 1.
% We follow, Eq. 16, Bayesian Cart Model Search, Chipman et al 
%
cart_llhood( Cart, Llhood ) :-
	cart_llhood_1( Cart, Leaves, Sum ),
	bb_get( knorm, Knorm ),
	Llhood is (Leaves * Knorm) + Sum.

cart_llhood_1( cart(_F,_S,L,R), Lvs, Llhood ) :-
	cart_llhood_1( L, LLvs, LLlhood ),
	cart_llhood_1( R, RLvs, RLlhood ),
	Lvs is LLvs + RLvs,
	Llhood is LLlhood + RLlhood.
cart_llhood_1( leaf(_D,LDIds), 1, Mterm ) :-
	% term_hash( LDIds, Hash ),
	% ( n_table( Hash, LDIds, Mterm ) ->
		% true
		% ; 
		bb_get( all_categories, Kats ),
		bb_get( num_of_categories, K ),
		% sum_of_lgammas_n_ik( Kats, LDIds, 0, LgGofNikS ),
		kv_compose_fixed_v( Kats, 1, KatPrs ),
		sum_of_lgammas_n_ik_v2( LDIds, KatPrs, 0, Ni, LgGofNikS ),
		% length( LDIds, Ni ), % 2005/10/13. This didnot account for
		% class_weight/2. now it is incorporate in above (as it should).
		NiAddK is Ni + K,
		logamma( NiAddK, LgGofNiAddK ),
		Mterm is LgGofNikS - LgGofNiAddK.
		% assert( n_table(LDIds,Mterm) )
	% ).

/* Pre 2005/10/12
sum_of_lgammas_n_ik_v2( [], KatPrs, LgGofNikS ) :-
	kv_sum_logamma_of_vs( KatPrs, 0, LgGofNikS ).
sum_of_lgammas_n_ik_v2( [Id|T], AccKatPrs, LgGofNikS ) :-
	has_category( Id, Kat ),
	kvs_add_one_to_v( AccKatPrs, Kat, NxKatPrs ),
	sum_of_lgammas_n_ik_v2( T, NxKatPrs, LgGofNikS ).
*/

sum_of_lgammas_n_ik_v2( [], KatPrs, Ni, Ni, LgGofNikS ) :-
	kv_sum_logamma_of_vs( KatPrs, 0, LgGofNikS ).
sum_of_lgammas_n_ik_v2( [IdLow-IdHgh|T], AccKatPrs, AccNi, Ni, LgGofNikS ) :-
     !,
     IdLim is IdHgh + 1,
     ( IdLow > IdHgh -> throw(funny_range_in_cart_lhood(IdLow,IdHgh)) ; true ),
     sum_of_lgammas_n_ik_v2_range( IdLow, IdLim, AccKatPrs, AccNi, NxKatPrs, NxNi ),
     sum_of_lgammas_n_ik_v2( T, NxKatPrs, NxNi, Ni, LgGofNikS ).
sum_of_lgammas_n_ik_v2( [Id|T], AccKatPrs, AccNi, Ni, LgGofNikS ) :-
     has_category( Id, Kat ),
     ( class_weight(Kat,W) -> true ; W is 1 ),
     NxNi is AccNi + W,
     kvs_add_n_to_v( AccKatPrs, Kat, W, NxKatPrs ),
     sum_of_lgammas_n_ik_v2( T, NxKatPrs, NxNi, Ni, LgGofNikS ).

sum_of_lgammas_n_ik_v2_range( IdLim, IdLim, AccKatPrs, AccNi, KatPrs, Ni ) :-
     !,
     KatPrs = AccKatPrs,
     Ni     = AccNi.
sum_of_lgammas_n_ik_v2_range( IdLow, IdLim, AccKatPrs, AccNi, KatPrs, Ni ) :-
     has_category( IdLow, Kat ),
     ( class_weight(Kat,W) -> true; W is 1 ),
     NxNi is AccNi + W,
     kvs_add_n_to_v( AccKatPrs, Kat, W, NxKatPrs ),
     NxIdLow is IdLow + 1,
     sum_of_lgammas_n_ik_v2_range( NxIdLow, IdLim, NxKatPrs, NxNi, KatPrs, Ni ).

% copied from kvs_add_one_to_v/3 below.
kvs_add_n_to_v( [Hk-Hv|T], K, N, All ) :-
	Hk @< K,
	!,
	All = [Hk-Hv|Ta],
	kvs_add_n_to_v( T, K, N, Ta ).
kvs_add_n_to_v( [Hk-Hv|T], _K, N, [Ha|Ta] ) :-
	Va is Hv + N,
	Ha = Hk-Va,
	Ta = T.

/*
% this is very un-steadfasty- but the fastest way to do this.
kvs_add_one_to_v( [Hk-Hv|T], K, All ) :-
	Hk @< K,
	!,
	All = [Hk-Hv|Ta],
	kvs_add_one_to_v( T, K, Ta ).
kvs_add_one_to_v( [Hk-Hv|T], _K, [Ha|Ta] ) :-
	Va is Hv + 1,
	Ha = Hk-Va,
	Ta = T.
*/

kv_sum_logamma_of_vs( [], Sum, Sum ).
kv_sum_logamma_of_vs( [_K-Tms|T], Acc, Sum ) :-
	logamma( Tms, LgG ),
	NxAcc is Acc + LgG,
	kv_sum_logamma_of_vs( T, NxAcc, Sum ).
/* 20051012: I dont think it is called from anywhere.
sum_of_lgammas_n_ik( [], _, PofGNik, PofGNik ).
sum_of_lgammas_n_ik( [Kat|Kats], LDIds, Acc, LgGofNikS ) :-
	findall( 1, (member(Id,LDIds),has_category(Id,Kat)), Ones ),
	length( Ones, N_ik ),
	N_ik_Inc is N_ik + 1,
	logamma( N_ik_Inc, LgGofN_ik_Inc ),
	NxAcc is Acc + LgGofN_ik_Inc,
	sum_of_lgammas_n_ik( Kats, LDIds, NxAcc, LgGofNikS ).
*/

/*
prod_of_gammas_n_ik( [], _, PofGNik, PofGNik ).
prod_of_gammas_n_ik( [Kat|TKats], LDIds, Acc, PofGNik ) :-
	findall( 1, has_category(_Id,Kat), Ones ),
	length( Ones, Nik ),
	gamma( Nik, GNik ),
	NxAcc is Acc * GNik ,
	prod_of_gammas_n_ik( TKats, LDIds, NxAcc, PofGNik ).
	*/
