:- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(mcmcms_top_dir) ).
:- ensure_loaded( library(requires) ).		%.
:- requires( sys_info/1 ).
:- requires( contains/2 ).
:- requires( working_directory/2 ).
:- requires( elm/1 ).
:- elm( 'bns/src/llhood/lhood_canonical_bdeu_multi_spl.pl' ).

jmlr_post_llhood_single( [File] ) :-
	% working_directory( Dir, _Old ),
	jmlr_chain_file_loads_data( File ),
	atom_concat( 'gunzip ', File, Gunzip ),
	sys_info( Gunzip ),
	atom_concat( FileStem, '.gz', File ),
	open( FileStem, read, In ),
	read( In, InTerm ),
	atom_concat( FileStem, '.llh', FileLLh ),
	open( FileLLh, write, Out ), 
	jmlr_post_llhood_on_stream( InTerm, last__,  0, In, Out ),
	close( Out ),
	close( In ),
	atom_concat( 'gzip ', FileStem, Gzip ),
	sys_info( Gzip ),
	atom_concat( 'chmod go+r ', File, Chmod ),
	sys_info( Chmod ).

jmlr_post_llhood_on_stream( end_of_file, _LstM, _LstLh, _In, _Out ) :- !.
jmlr_post_llhood_on_stream( c(C), LstM, LstLh, In, Out ) :-
	!,
	( C == LstM -> 
		CLh = LstLh
		;
		model_llhood( C, CFmCnts ),
		sum_model_llhood_family_contributions( CFmCnts, 0, CLh )
	),
	write( Out, CLh), nl( Out ),
	read( In, NxTerm ),
	jmlr_post_llhood_on_stream( NxTerm, C, CLh, In, Out ).
jmlr_post_llhood_on_stream( _Oth, LstM, LstLh, In, Out ) :-
	read( In, NxTerm ),
	jmlr_post_llhood_on_stream( NxTerm, LstM, LstLh, In, Out ).

sum_model_llhood_family_contributions( [], Sum, Sum ).
sum_model_llhood_family_contributions( [_-_+Cnt|T], Acc, Sum ) :-
	NxAcc is Acc + Cnt,
	sum_model_llhood_family_contributions( T, NxAcc, Sum ).
	

jmlr_chain_file_loads_data( File ) :-
	atom_codes( File, FileCs ),
	first_contains_pics( ["tal"-alarm,"thf"-hailfinder,"tsc"-insurance,"tp1"-parity1,"tp2"-parity2], FileCs, TrueBn ),
	atom_concat( '../data/', TrueBn, DataStem ),
	first_contains_pics( ["d500"-'_500',"d1K"-'_1K'], FileCs, SizeAtm ),
	atom_concat( DataStem, SizeAtm, DataFile ),
	write( ensure_loaded( DataFile ) ), nl,
	ensure_loaded( DataFile ),
	atom_concat( TrueBn, '_vrs', TrueVrs ),
	atom_concat( '../true/', TrueVrs, TrueVrsFile ),
	ensure_loaded( TrueVrsFile ).

% first_contains_pics( [], _Long, Picked).
first_contains_pics( [Hcntcs-Hatm|_T], Long, Picked) :-
	contains( Long, Hcntcs ),
	!,
	Picked = Hatm.
first_contains_pics( [_H|T], Long, Picked ) :-
	first_contains_pics( T, Long, Picked ).
