% comparison_data(LossFs,TrueM,DataSize,ModSpace,BStg,RunLgth,Prior,Lkhood,SeedId,StrGoal).

% :- ensure_loaded( '../auxil/include_sc_auxil' ).
% :- ensure_loaded( '../../auxil/create_mvisits' ).

:- ensure_loaded( 'list_of_first_n_nats' ). % 3.
:- ensure_loaded( slp_has ). % 3.

comparison_data( 
				[loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount],
				TrueBase,
				DataPop,
				rm,
				uc,
				250000,
				'slps/step_known_causes_ind.slp',
				% '../bns/src/llhood/lhood_canonical_bdeu_multi_inc.pl',
				'../bns/src/llhood/lhood_canonical_bdeu_multi_spl.pl',
				% 103, % saemus
				% 451, % pc266
				772, % minotaur
				none,
				% none/include_sc_auxil,
				[],
				bn/[Nats,PaLess,Indcs]
						) :-
	member( TrueBase-NNds, [alarm-37,insurance-27,hailfinder-56,parity1-22,parity2-100] ),
	member( DataPop, [500,1000] ),
	atom_concat( 'true/', TrueBase, DirTrue ),
	atom_concat( DirTrue, '.slp', True ),
	slp_has( True, Indcs, PaLess ),
 	list_of_first_n_nats( NNds, [], Nats ).

% Also need to define, model_id/2, prior_id/2, lhood_id/2.
% These provide shorthands of the respective comparison_data/n entries
% which will appear in the results directories.

model_id( alarm, al ).
model_id( insurance, sc ).
model_id( hailfinder, hf ).
model_id( parity1, p1 ).
model_id( parity2, p2 ).

% prior_id( 'bn_or_pick_unif.slp', ou ).
% prior_id( 'stepped.slp', pd ).
% prior_id( 'step_known_causes.slp', pk ).
prior_id( 'step_known_causes_ind.slp', ki ).

% lhood_id( '../bns/src/llhood/lhood_canonical_uai01.pl', ua ).
% lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi.pl', md ).
% lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_set.pl', st ).
% lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_inc.pl', nc ).
lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_spl.pl', lr ).

