:- ensure_loaded( '../cdata/true_nodes_have_nof_pa' ).		% /4.
:- ensure_loaded( '../slps/inc_indep' ). 	% /2.


true_to_fact_inc_independencies( [] ).
true_to_fact_inc_independencies( [H|T] ) :-
	true_nodes_have_nof_pa( H, Stem, _, Bn ),
	bn_to_empty_and_nodes( Bn, _Empty, Nodes ),
	feed_whole_bn_for_dependencies( Bn, [], Dep ),
	% all_pairwise_independencies( Bn, Ipcs ),
	atom_concat( Stem, '_inc_findpcs.pl', FIndpcs ),
	open( FIndpcs, write, Out ),
	nodes_to_independence_facts_from_dependencies( Nodes, Dep, Out ),
	close( Out ),
	true_to_fact_independencies( T ).

pairwise_independencies_to_recorded_facts( [], _Out ).
pairwise_independencies_to_recorded_facts( [Nd1-Nd2|T], Out ) :-
	write( Out, indep(Nd1,Nd2) ), write( Out, '.' ), nl( Out ),
	pairwise_independencies_to_recorded_facts( T, Out ).

nodes_to_independence_facts_from_dependencies( [], _Dep, _Out ).
nodes_to_independence_facts_from_dependencies( [H|T], Dep, Out ) :-
	parents_to_independence_facts_from_dependencies( T, H, Dep, Out ),
	nodes_to_independence_facts_from_dependencies( T, Dep, Out ).

parents_to_independence_facts_from_dependencies( [], _Par, _Deps, _Out ).
parents_to_independence_facts_from_dependencies( [H|T], Par, Deps, Out ) :-
	( ord_member(Par-H,Deps) ->
		true
		;
		write( Out, indep(Par,H) ), write( Out, '.' ), nl( Out )
	),
	parents_to_independence_facts_from_dependencies( T, Par, Deps, Out ).

bn_to_empty_and_nodes( [], [], [] ).
bn_to_empty_and_nodes( [H-_|T], [H-[]|R], [H|N] ) :-
	bn_to_empty_and_nodes( T, R, N ).

feed_whole_bn_for_dependencies( [], Dep, Dep ).
feed_whole_bn_for_dependencies( [H-PaH|T], InDep, OutDep ) :-
	% write( h(H) ), nl,
	feed_pa_for_dependencies( PaH, H, InDep, NxtDep ),
	feed_whole_bn_for_dependencies( T, NxtDep, OutDep ).

feed_pa_for_dependencies( [], _Ch, Deps, Deps ).
feed_pa_for_dependencies( [H|T], Ch, InDeps, OutDeps ) :-
	add_child( Ch, H, InDeps, MidDeps ),
	feed_pa_for_dependencies( T, Ch, MidDeps, OutDeps ).
