:- ensure_loaded( cmv_sets ).		% gen_cmv_sets/3, row_sanity_check/4.
:- ensure_loaded( cmv_branch ).	% /9.

test_cmv_branch :-
	gen_cmv_sets( 8, Ids, TopTbl ),
	write( user_error, doing_row(1) ), nl( user_error ),
	split_table( TopTbl, [], J, RvL, R, Edge, RmRows ),
	% report feature increments
	cmv_branch( RvL, R, Ids, Edge, J, RmRows, LIds, RIds, LTbl, RTbl ),
	% write( ltbl(LTbl) ), nl,
	% write( rtbl(RTbl) ), nl,
	% write( rids(RIds) ), nl,
	% write( lids(LIds) ), nl,
	ord_union(LIds,RIds,LRIds),
	( LRIds == Ids ->
			( ord_disjoint(LIds,RIds) ->
				table_sanity_check(LTbl,LIds),
				table_sanity_check(RTbl,RIds)
				;
				ord_intersection(LIds,RIds,CommonIds),
				write( commonids(CommonIds) ), nl,
				write( aha_left(LIds) ), nl,
				write( aha_rigt(RIds) ), nl,
				abort
			)
			;
			write( opa_left(LIds) ), nl,
			write( opa_rigt(RIds) ), nl,
			abort
	),
	fail.
	
table_sanity_check( [], _Ids ).
table_sanity_check( [row(J,FvIdPrs,Edge)|T], Ids ) :-
	% write( checking_row(J,FvIdPrs,Edge) ), nl,
	row_sanity_check( FvIdPrs, [], Edge, InRowIds ),
	( InRowIds==Ids ->  true    % write( ok_line(Ith) ), nl 
		; ord_subtract( Ids, InRowIds, Diff ), 
			write( problem_with_line(J,InRowIds,Diff,Ids) ), nl, abort ),
	table_sanity_check( T, Ids ).

split_table( [row(J,FvIdPrs,Edge)|T], Seen, J, RvL, R, Edge, RmRows ) :-
	split_fvid_pairs( FvIdPrs, [], RvL, R ),
	% rev_append(...),
	append( Seen, T, RmRows ).
	% RmRows = Seen,
split_table( [H|T], Seen, J, RvL, R, Edge, RmRows ) :-
% split_table( [row(J,FvIdPrs,Edge)|T], Seen, J, RvL, R, Edge, RmRows ) :-
	write( user_error, done_a_row ), nl( user_error ),
	append( Seen, [H], NxSeen ),
	split_table( T, NxSeen, J, RvL, R, Edge, RmRows ).

split_fvid_pairs( [Fv-Ids|T], Acc, [Fv-Ids|Acc], T ).
split_fvid_pairs( [Fv-Ids|T], Acc, RvL, R ) :-
	split_fvid_pairs( T, [Fv-Ids|Acc], RvL, R ).
