% this is a run in the spirit of Fig. 7 (LHS) of the paper.
% Be warned to change Dir to some filesystem with loads of free space.
% To reproduce the likelihood trajectory file for the experiment do:
% (a)   run the experiment by, starting a prolog (SICStus or Yap) and
%       compile( bcw_fig7_edit ).
%       run_bcw_fig7_edit.
%       halt.
% (b)   cd into out_bcw_fig7_edit or directory you have chosen and 
%       gunzip tr_uc_rm_edit_data_ed_i60K__s1.gz
% (c)   start a prolog and
%       ['<mcmcms_dir>/carts/auxil/lld_stats_for_stem'].
%       lld_stats_for_stem( [tr_uc_rm_edit_data_ed_i60K__s1] ).
%       halt.
% (d)   gzip tr_uc_rm_edit_data_ed_i60K__s1
%
% The likelihoods for the models in the chain are in tr_uc_rm_edit_data_ed_i60K__s1.llhoods
% Use gnuplot manually or via mcmcms/auxil/gsplay.pl to greate a .eps file from
% these numbers. Note that to get a scale similar to that in the paper you 
% need to restrict the y-axis to [-75,-60].

:- ensure_loaded( '../../run' ).
:- elm( 'carts/src/lhood' ).            % llhood_w_diff/5, model_llhood/2.
:- elm( 'auxil/create_mvisits' ).       % exec_extension/2.
:- elm( 'carts/src/split_cart_to_model' ). % /2.
% :- elm( 'carts/src/display_model' ). % /2.
:- bb_put( to_model, split_cart_to_model(In,Out)/In/Out ).

run_bcw_fig7_edit :-
	Dir = '/local/d1p1/nicos/kong/ijcai05/bcw/rr_bcw_fig7_edit',
	% Dir = out_bcw_fig7_edit,
	Runs = [		runs_file( runs_bcw_fig7_edit ),
				results_dir( Dir ),
				% display(next_display_at),
				print([24,28,29,31])
		],
	run( Runs ).
