% This script reproduces the run 3pu_3h25 which is the left part of Fig. 8.
% Because of the evolution of the software, the results to this experiment
% slightly different from the results in the paper.
% To reproduce the graph :
% (a)   
%       run the experiment by, starting a prolog (SICStus or Yap) and
%       compile( run_3pu_3h25_fig8_right )
%       run_3pu_3h25_fig8_right.
%       halt.
% (b)
%       cd into uai01_fig8r_3pu_3h25
%       create the counts by 
%       gunzip tr_cd28_rm_asia_data_full_3pu_3h25_i500K__s1.gz
%       <mcmcms_top_dir>/bns/auxil/jc_count_parents.perl tr_cd28_rm_asia_data_full_3pu_3h25_i500K__s1 > tr_cd28_rm_asia_data_full_3pu_3h25_i500K__s1.counts
%       gzip tr_cd28_rm_asia_data_full_3pu_3h25_i500K__s1
% (c) 
%       to visualise learned model at cut-off 0.95,
%       start a prolog and run: (NOTE: you need graphviz for this part.)
%       compile( '<mcmcms_top_dir>/bns/auxil/disp_cut_off' ).
%       display_cut_off( [0.95,'tr_cd28_rm_asia_data_full_3pu_3h25_i500K__s1.counts'] ).

:- ensure_loaded( '../../run' ).
:- elm( 'bns/src/llhood/lhood_canonical_uai01' ).
:- elm( 'auxil/create_mvisits' ).

asia_data_full.
data_format(data(_,_,_,_,_,_,_,_)).
possible_values( _, [0,1] ).

run_3pu_3h25_fig8_right :-
	% Dir = '/local/d1p1/nicos/uai01_vs40/uai01_fig8r_3pu_3h25',
	Dir = uai01_fig8r_3pu_3h25,
	Runs = [
			runs_file( runs_3pu_3h25_fig8_right ),
		 	results_dir( Dir )
		],
	run( Runs ).
