
log_params( -0.203836352383858 ).

%%% llhood_ratio( Mod1, Mod2, LogofRatio ) :-

llhood_ratio( Mod1, Mod2, LogofRatio ) :-
     sci_lhood( Mod1, Lhd1 ),
     sci_lhood( Mod2, Lhd2 ),
     % LogofRatio is log(Lhd1/Lhd2).
     LogofRatio is Lhd1 - Lhd2.

sci_lhood( Mod, Lhd ) :-
     indices_to_grab_list_and_args( Mod, 1, Grab, Args ),
     data_inputs_length( L ),
     length_n_last( L, Args, Y ),  % Args should have a Var at its tail before here
     % append( Args, [Y], DataArgs ),
     Data =.. [data|Args],
     findall( Grab-Y, Data, Grabs ), 
     write( grabs(Grabs) ), nl,
     keysort( Grabs, Sorts ), 
     Sorts = [X1-Y1|TSorts],
     Nx is 1, 
     % NUx is Y1,
     count_combs_and_successes( TSorts, X1, Nx, Y1, CSs ),
     write( css(CSs) ), nl,
     log_params( Lparams ),
     marginal_from_combs( CSs, Lparams, Lparams, Lhd ).

marginal_from_combs( [], Lhd, _Lps, Lhd ).
marginal_from_combs( [Nx-NUx|T], Acc, Lps, Lhd ) :-
     Nxt is Acc + lgamma(NUx + 0.9) + lgamma(Nx-NUx+0.9) - lgamma(1.8+Nx),
     marginal_from_combs( T, Nxt, Lps, Lhd ).

length_n_last( 0, [Y], Y ) :- !.
length_n_last( I, [_|T], Y ) :-
     NxI is I - 1,
     length_n_last( NxI, T, Y ).

indices_to_grab_list_and_args( [], _I, [], _ ).
indices_to_grab_list_and_args( [H|T], I, Grab, Args ) :-
     Args = [V|TArgs],
     ( H =:= I -> 
          R = T,
          Grab = [V|TGrab]
          ; 
          R = [H|T],
          Grab = TGrab
     ),
     NxI is I + 1,
     indices_to_grab_list_and_args( R, NxI, TGrab, TArgs ).

% each Sort is Xs-Y (sorted on Xs)
% each CS has Cobs-Succ, Number of times a Combination of Inputs appeared
% and Succ the number of successes (Y=1) 
count_combs_and_successes( [], _X, Nx, NUx, [Nx-NUx] ).
count_combs_and_successes( [Xh-Yh|T], X, Nx, NUx, CSs ) :- 
     ( X == Xh -> 
          NxtNx is Nx + 1,
          NxtNUx is NUx + Yh,
          TCSs = CSs
          ;
          NxtNx is 1,
          NxtNUx is Yh,
          CSs = [Nx-NUx|TCSs]
     ),
     count_combs_and_successes( T, Xh, NxtNx, NxtNUx, TCSs ).

