% ord_split( Set, Marker, Left, Right ) :-
% Split Set, on Marker giving Left and Right. Right includes
% Left contains all set elements @< than Marker, with the remainder
% going to Right. If Marker is present in the Set, it will be 
% the first element in Right.
%
ord_split( [], _M, [], [] ).
ord_split( [H|T], M, L, R ) :-
	H @< M, 
	!,
	L = [H|TL],
	ord_split( T, M, TL, R ).
ord_split( [H|T], _M, [], [H|T] ).
