:- ensure_loaded( library(lists) ).     % member/2
% :- requires( member/2 ).

% select_either_all( Term, Rec, Preferred, FallBack, Sel ) :-
% Term selects Rec into Sel from all unifying element of Preferred, if 
% at least one exists, or from all elements in FallBack otherwise.
%
select_either_all( Name, List1, List2, Sel ) :-
     Term =.. [Name,Rec],
     select_either_all( Term, Rec, List1, List2, Sel ).

select_either_all( Term, Rec, List1, List2, Sel ) :-
     findall( Rec, member(Term,List1), Sel1 ),
	( Sel1 == [] -> 
          findall( Rec, member(Term,List2), Sel )
          ;
          Sel = Sel1
	).
